Ext.Widget.FrTvProgram = function(posX, posY, id) {

    var mod = this.QoDesk.getModule('qo-widgets');

    var store = new Ext.data.JsonStore({
            baseParams: {
                    moduleId: mod.moduleId,
                    fileName: 'widgets/french_tv_program/php/load.php'
            },
            fields: ['id', 'chaine', 'heure', 'titre', 'desc', 'rawTitre','img'],
            id: 'id',
            root: 'items',
            url: mod.app.connection
    });

    var dsDate = new Ext.data.JsonStore({
            autoLoad: true,
            baseParams: {
                    moduleId: mod.moduleId,
                    fileName: 'widgets/french_tv_program/php/load_date.php'
            },
            fields: ['id', 'uri', 'title'],
            id: 'id',
            root: 'items',
            url: mod.app.connection
    });

    function renderChaine(val){
        if(val == 'Programme TF1' ) {
            return '<img src="system/modules/qo-widgets/widgets/french_tv_program/images/tf1.gif" />';
        }
        if(val == 'Programme France 2' ) {
            return '<img src="system/modules/qo-widgets/widgets/french_tv_program/images/france2.gif" />';
        }
        if(val == 'Programme France 3' ) {
            return '<img src="system/modules/qo-widgets/widgets/french_tv_program/images/france3.gif" />';
        }
        if(val == 'Programme Canal+' ) {
            return '<img src="system/modules/qo-widgets/widgets/french_tv_program/images/canal+.gif" />';
        }
        if(val == 'Programme Arte' ) {
            return '<img src="system/modules/qo-widgets/widgets/french_tv_program/images/arte.gif" />';
        }
        if(val == 'Programme M6' ) {
            return '<img src="system/modules/qo-widgets/widgets/french_tv_program/images/m6.gif" />';
        }
        return val;
    }



    function renderTitle(value, p, record) {
        p.attr = 'ext:qwidth="200" ext:qtitle="' + record.data.rawTitre + '" ext:qtip="<table><tr><td style=\'vertical-align: middle\'><img src=\'' + record.data.img + '\' style=\'margin-right:5px\' /></td><td style=\'vertical-align: top\'>' + record.data.desc + '</td></tr></table>"';
        return value;
    }

    //Grid
    var grid = new Ext.grid.GridPanel({
        store: store,
        hideHeaders: true,
        columns: [
            {header: "chaine", width: 40, dataIndex: 'chaine', renderer: renderChaine, sortable: false},
            {id:"titre", header: "Titre", dataIndex: 'titre', renderer: renderTitle, sortable: false}
        ],
        listeners: {
            render: function() {
              this.store.load();
            }
        },
        autoExpandColumn : 'titre',
        loadMask: true,
        bbar: [{
                iconCls:'qo-widgets-french_tv_program-refresh',
                //text:'&nbsp;&nbsp;&nbsp;',
                handler: function() {
                  store.reload();
                },
                tooltip: 'Refresh'
        },{
                xtype:'combo',
                store: dsDate,
                displayField:'title',
                typeAhead: false,
                editable: false,
                mode: 'remote',
                forceSelection: true,
                triggerAction: 'all',
                emptyText:'Select a date...',
                selectOnFocus:true,
                listeners: {
                    select: function( combo, record, NumberIndex ) {
                        store.reload({params:"moduleId="+mod.moduleId+"&fileName=widgets/french_tv_program/php/load.php&uri="+this.store.getAt(NumberIndex).data.uri});

                    }
                }


        }]
    });



    var widget = new Ext.ux.Widget({
    scope: this,
    width: 250,
    height: 335,
    id:id,
    launcher: 'FrTvProgram',
    resizable: false,
    goToX: posX,
    goToY: posY,
    layout:'fit',
    items: grid

    });

}
