Ext.ux.WidgetWeatherSearchField = Ext.extend(Ext.form.TwinTriggerField, {
 initComponent : function() {
   Ext.ux.WidgetWeatherSearchField.superclass.initComponent.call(this);
   this.on('specialkey', function(f, e){
     if(e.getKey() == e.ENTER){
       this.onTrigger2Click();
     }
   }, this);
 },

 validationEvent:false,
 validateOnBlur:false,
 trigger1Class:'x-form-clear-trigger',
 trigger2Class:'x-form-search-trigger',
 hideTrigger1:true,
 width:180,
 hasSearch : false,
 xtype:'WidgetWeatherSearchField',
 paramName : 'q',

 onTrigger1Click : function(){
         if(this.hasSearch){
                 this.el.dom.value = '';
                 this.store.reload();
                 this.triggers[0].hide();
                 this.hasSearch = false;
         }
 },

 onTrigger2Click : function(){
       var v = this.getRawValue();
       if(v.length < 1){
                this.onTrigger1Click();
                return;
       }
       this.store.load({params: {'q':v}});
       this.hasSearch = true;
       this.triggers[0].show();
}
});

Ext.ComponentMgr.registerType('WidgetWeatherSearchField', Ext.ux.WidgetWeatherSearchField);

Ext.Widget.weather = function(posX, posY, id) {

    var menu;
    var units = 'metric';
    var IdentCity;

    var mod = this.QoDesk.getModule('qo-widgets');

    // Load City for this widget's ID
    Ext.Ajax.request({
            url: mod.app.connection,
            params: {
                    moduleId: mod.moduleId,
                    fileName: 'widgets/weather/php/loadCity.php',
                    widgetID: id
            },success: function(o){
                if(o && o.responseText && Ext.decode(o.responseText).success && Ext.decode(o.responseText).nb != 0 ){
                        var r = Ext.decode(o.responseText);
                        getInfo(r.IdentCity);
                        IdentCity = r.IdentCity;
                        units = r.units;
                }
            }
    });

    function onContextMenu(e){

        e.preventDefault();
        e.stopEvent();

        if(!menu){ // create context menu on first right click
            menu = new Ext.menu.Menu([{
                id: 'qo-widgets-weather-units',
                text: 'Units',
                menu: {
                  items: [
                  '<b class="menu-title">Choose units</b>',
                  {
                      text: 'Metric',
                      checked: (units == 'metric' ) ? true:false,
                      group: 'units',
                      checkHandler: function(){
                        units = 'metric';
                        getInfo(IdentCity);
                      }
                  }, {
                      text: 'English',
                      checked: (units == 'metric' ) ? false:true,
                      group: 'units',
                      checkHandler: function(){
                        units = 'english';
                        getInfo(IdentCity);
                      }
                  }]
                }
            },'-',{
                text:'Refresh',
                iconCls:'qo-widgets-weather-refresh',
                handler: function() {
                  getInfo(IdentCity);
                }
            }]);
        }
        menu.showAt(e.getPoint());
    }


    function removeCityOnClose(id) {
      Ext.Ajax.request({
              url: mod.app.connection,
              params: {
                      moduleId: mod.moduleId,
                      fileName: 'widgets/weather/php/removeCityOnClose.php',
                      widgetID: id
              }
      });
    } //removeCityOnClose

    function saveCity(IdentCity, id) {
      Ext.Ajax.request({
              url: mod.app.connection,
              params: {
                      moduleId: mod.moduleId,
                      fileName: 'widgets/weather/php/setCity.php',
                      widgetID: id,
                      IdentCity: IdentCity,
                      units: units
              }
      });
    } //saveCity

    function getInfo(IdentCity) {

      Ext.get(id).mask('Loading...');

      var loadDataConnexion = new Ext.data.Connection();
      loadDataConnexion.request({
          scope: this,
          url: mod.app.connection,
          params: {
              moduleId: mod.moduleId,
              fileName: 'widgets/weather/php/get-info.php',
              city: IdentCity
          },

          success: function(response, options) {

              var o = Ext.util.JSON.decode(response.responseText);

              var u = (units == 'metric')?o.data.cc.tmp.metric:o.data.cc.tmp.english;

              tplWidget.overwrite(widget.body, {img:o.data.cc.icon, temp:u, location:o.data.city.libel});
              saveCity(IdentCity, id);
              Ext.get(id).unmask();

          }
      });
    }

    var dsCity = new Ext.data.Store({
            proxy: new Ext.data.HttpProxy({
                url: mod.app.connection+'?moduleId='+mod.moduleId+'&fileName=widgets/weather/php/search-location.php'
            }),
            reader: new Ext.data.JsonReader({
                root:'items',
                id:'ident'
            }, [
                {name: 'ident'},
                {name: 'city'}
            ])
    });

    // Custom rendering Template for the View
    var resultTpl = new Ext.XTemplate(
        '<tpl for=".">',
          '<div class="city-wrap">',
              '<div class="city">{city}</div>',
          '</div>',
        '</tpl>'
    );

    var weatherDrawer = new drawer({
            size      : 156,
            side      : 's',
            animate   : true,
            modal: false,
            plain     :  true,
            layout    : 'fit',
            items: [{
                xtype:'WidgetWeatherSearchField',
                store: dsCity,
                width:218,
                emptyText:'Search a city...'
            },{
                xtype:'panel',
                 autoScroll: true,
                height: 90,
                //Height: true,
                autoWidth: true,
                items: [{
                    xtype:'dataview',
                    id: 'qo-widgets-weather-dataview',
                    tpl: resultTpl,
                    store: dsCity,
                    itemSelector: 'div.city-wrap',
                    overClass:'x-view-over',
                    singleSelect: true,
                    listeners: {
                      click: function(view, NumIndex, node, e) {
                        Ext.getCmp('qo-widgets-weather-display').enable();
                      }

                    }
                }]
            }],
            bbar: ['->',{
                    text:'Display',
                    id: 'qo-widgets-weather-display',
                    scope:this,
                    disabled: true,
                    handler:function() {
                      var o = Ext.getCmp('qo-widgets-weather-dataview').getSelectedRecords();
                      getInfo(o[0].data.ident);
                      IdentCity = o[0].data.ident;
                    }
            },{
                    text:'Hide',
                    scope:this,
                    handler:function() {
                            var e = widget.drawers.s.getState();
                            if( e.x < 0 ) {
                                    widget.drawers.s.show();
                            } else {
                                    widget.drawers.s.hide();
                            }
                      }
            }]

    });

    var tplWidget = new Ext.XTemplate(
            '<tpl for=".">',
            '<table class="qo-widgets-weather-table">',
              '<tr>',
                '<td rowspan="2" class="qo-widgets-weather-img"><img src="system/modules/qo-widgets/widgets/weather/images/48x48/{img}.png" /></td>',
                '<td class="qo-widgets-weather-temp">{temp}</td>',
              '</tr>',
              '<tr>',
                '<td class="qo-widgets-weather-location">{location}</td>',
              '</tr>',
            '</table>',
            '</tpl>'
    );

    tplWidget.compile();

    var widget = new Ext.ux.Widget({
        scope: this,
        width: 175,
        height: 86,
        id:id,
        launcher: 'weather',
        resizable: false,
        goToX: posX,
        goToY: posY,
        plugins : [
                weatherDrawer
        ],
        listeners: {
          close: function(p) {
            removeCityOnClose(p.id);
          }
        }

    });

    widget.el.on('click', function() { widget.drawers.s.show(); }, this);
    widget.el.on('contextmenu', onContextMenu, this);




}